//Copyright 2010 mindstormsguy@verizon.net
/******************************************************************
		This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**********************************************************************/


//Includes
#include <tigcclib.h>

//Global Variables
//0 == empty, 1 == p1, 2 == p2
short int board[3][3];
//No bools in TIGCC, 0 == true
short int cont = 0;
short int row;
short int column;
short int i;
short int j;
//"X" Sprite
unsigned short int x[] = {0x8001, 0x4002, 0x2004, 0x1008, 0x0810, 0x0420, 0x0240, 0x0180, 0x0180, 0x0240, 0x0420, 0x0810, 0x1008, 0x2004, 0x4002, 0x8001};
//"O" Sprite
unsigned short int o[] = {0x07E0, 0x0810, 0x300C, 0x2004, 0x4002, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x4002, 0x2004, 0x300C, 0x0810, 0x07E0};

//Functions
short int getkey() {
	short key = ngetchx();
	if (key == KEY_ESC)
		exit(0);
	else
		return key;
}

short int Win(short int turn) {
	//Check Horizontals
	for (i = 0; i < 3; i++) {
		if (board[i][0] == turn && board[i][1] == turn && board[i][2] == turn)
			return 1;
	}
	//Check Verticals
	for (i = 0; i < 3; i++) {
		if (board[0][i] == turn && board[1][i] == turn && board[2][i] == turn)
			return 1;
	}
	//Check Diagonals
	if (board[0][0] == turn && board[1][1] == turn && board[2][2] == turn)
		return 1;
	if (board[0][2] == turn && board[1][1] == turn && board[2][0] == turn)
		return 1;
	return 0;
}

short int Tie() {
	short int check = 0;
	for (i = 0; i < 3; i++) {
		for (j = 0; j < 3; j++) {
			if (board[i][j] == 0)
				check++;
		}
	}
	if (check == 0){
		return 1;
	}
	return 0;
}

short int CWin() {
		//Horizontals
    //Top Row (1-2-3)
    if ( board[0][0] == 1 && board[0][1] == 1 && board[0][2] == 0) {
        board[0][2] = 2;
        return 1;
    }
    else if (board[0][0] == 1 && board[0][1] == 0 && board[0][2] == 1) {
        board[0][1] = 2;
        return 1;
    }
    else if (board[0][0] == 0 && board[0][1] == 1 && board[0][2] == 1) {
        board[0][0] = 2;
        return 1;
    }
    //Middle Row(4-5-6)
    else if (board[1][0] == 1 && board[1][1] == 1 && board[1][2] == 0) {
        board[1][2] = 2;
        return 1;
    }
    else if (board[1][0] == 1 && board[1][1] == 0 && board[1][2] == 1) {
        board[1][1] = 2;
        return 1;
    }
    else if (board[1][0] == 0 && board[1][1] == 1 && board[1][2] == 1) {
        board[1][0] = 2;
        return 1;
    }
    //Bottom Row(7-8-9)
    else if (board[2][0] == 1 && board[2][1] == 1 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else if (board[2][0] == 1 && board[2][1] == 0 && board[2][2] == 1) {
        board[2][1] = 2;
        return 1;
    }
    else if (board[2][0] == 0 && board[2][1] == 1 && board[2][2] == 1) {
        board[2][0] = 2;
        return 1;
    }
    //Verticals
    //Left Collumn (1-4-7)
    else if (board[0][0] == 1 && board[1][0] == 1 && board[2][0] == 0) {
        board[2][0] = 2;
        return 1;
    }
    else if (board[0][0] == 1 && board[1][0] == 0 && board[2][0] == 1) {
        board[1][0] = 2;
        return 1;
    }
    else if (board[0][0] == 0 && board[1][0] == 1 && board[2][0] == 1) {
        board[0][0] = 2;
        return 1;
    }
   //Middle Collumn (2-5-8)
    else if (board[0][1] == 1 && board[1][1] == 1 && board[2][1] == 0) {
        board[2][1] = 2;
        return 1;
    }
    else if (board[0][1] == 1 && board[1][1] == 0 && board[2][1] == 1) {
        board[1][1] = 2;
        return 1;
    }
    else if (board[0][1] == 0 && board[1][1] == 1 && board[2][1] == 1) {
        board[0][1] = 2;
        return 1;
    }
    //Right Collumn (3-6-9)
    else if (board[0][2] == 1 && board[1][2] == 1 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else if (board[0][2] == 1 && board[1][2] == 0 && board[2][2] == 1) {
        board[1][2] = 2;
        return 1;
    }
    else if (board[0][2] == 0 && board[1][2] == 1 && board[2][2] == 1) {
        board[0][2] = 2;
        return 1;
    }
    //Diagonals
    //TR - BL (3-5-7)
    else if (board[0][2] == 1 && board[1][1] == 1 && board[2][0] == 0) {
        board[2][0] = 2;
        return 1;
    }
    else if (board[0][2] == 1 && board[1][1] == 0 && board[2][0] == 1) {
        board[1][1] = 2;
        return 1;
    }
    else if (board[0][2] == 0 && board[1][1] == 1 && board[2][0] == 1) {
        board[0][2] = 2;
        return 1;
    }
    //TL - BR (1-5-9)
    else if (board[0][0] == 1 && board[1][1] == 1 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else if (board[0][0] == 1 && board[1][1] == 0 && board[2][2] == 1) {
        board[1][1] = 2;
        return 1;
    }
    else if (board[0][0] == 0 && board[1][1] == 1 && board[2][2] == 1) {
        board[0][0] = 2;
        return 1;
    }
    //Can't Win
    else {
        return 0;
    }
}
short int BlockH() {
   //Horizontals
   //Top Row (1-2-3)
    if ( board[0][0] == 2 && board[0][1] == 2 && board[0][2] == 0) {
        board[0][2] = 2;
        return 1;
    }
    else if (board[0][0] == 2 && board[0][1] == 0 && board[0][2] == 2) {
        board[0][1] = 2;
        return 1;
    }
    else if (board[0][0] == 0 && board[0][1] == 2 && board[0][2] == 2) {
        board[0][0] = 2;
        return 1;
    }
    //Middle Row(4-5-6)
    else if (board[1][0] == 2 && board[1][1] == 2 && board[1][2] == 0) {
        board[1][2] = 2;
        return 1;
    }
    else if (board[1][0] == 2 && board[1][1] == 0 && board[1][2] == 2) {
        board[1][1] = 2;
        return 1;
    }
    else if (board[1][0] == 0 && board[1][1] == 2 && board[1][2] == 2) {
        board[1][0] = 2;
        return 1;
    }
    //Bottom Row(7-8-9)
    else if (board[2][0] == 2 && board[2][1] == 2 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else if (board[2][0] == 2 && board[2][1] == 0 && board[2][2] == 2) {
        board[2][1] = 2;
        return 1;
    }
    else if (board[2][0] == 0 && board[2][1] == 2 && board[2][2] == 2) {
        board[2][0] = 2;
        return 1;
    }
    //Verticals
    //Left Collumn (1-4-7)
    else if (board[0][0] == 2 && board[1][0] == 2 && board[2][0] == 0) {
        board[2][0] = 2;
        return 1;
    }
    else if (board[0][0] == 2 && board[1][0] == 0 && board[2][0] == 2) {
        board[1][0] = 2;
        return 1;
    }
    else if (board[0][0] == 0 && board[1][0] == 2 && board[2][0] == 2) {
        board[0][0] = 2;
        return 1;
    }
   //Middle Collumn (2-5-8)
    else if (board[0][1] == 2 && board[1][1] == 2 && board[2][1] == 0) {
        board[2][1] = 2;
        return 1;
    }
    else if (board[0][1] == 2 && board[1][1] == 0 && board[2][1] == 2) {
        board[1][1] = 2;
        return 1;
    }
    else if (board[0][1] == 0 && board[1][1] == 2 && board[2][1] == 2) {
        board[0][1] = 2;
        return 1;
    }
    //Right Collumn (3-6-9)
    else if (board[0][2] == 2 && board[1][2] == 2 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else if (board[0][2] == 2 && board[1][2] == 0 && board[2][2] == 2) {
        board[1][2] = 2;
        return 1;
    }
    else if (board[0][2] == 0 && board[1][2] == 2 && board[2][2] == 2) {
        board[0][2] = 2;
        return 1;
    }
    //Diagonals
    //TR - BL (3-5-7)
    else if (board[0][2] == 2 && board[1][1] == 2 && board[2][0] == 0) {
        board[2][0] = 2;
        return 1;
    }
    else if (board[0][2] == 2 && board[1][1] == 0 && board[2][0] == 2) {
        board[1][1] = 2;
        return 1;
    }
    else if (board[0][2] == 0 && board[1][1] == 2 && board[2][0] == 2) {
        board[0][2] = 2;
        return 1;
    }
    //TL - BR (1-5-9)
    else if (board[0][0] == 2 && board[1][1] == 2 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else if (board[0][0] == 2 && board[1][1] == 0 && board[2][2] == 2) {
        board[1][1] = 2;
        return 1;
    }
    else if (board[0][0] == 0 && board[1][1] == 2 && board[2][2] == 2) {
        board[0][0] = 2;
        return 1;
    }
    //Can't Win
    else {
        return 0;
    }
}
short int BlockSH() {
    if (board[0][0] == 2 && board[2][2] == 2 && board[2][1] == 0) {
        board[2][1] = 2;
        return 1;
    }
    else if (board[0][2] == 2 && board[2][0] == 2 && board[2][1] == 0) {
        board[2][1] = 2;
        return 1;
    }
    else if (board[0][0] == 2 && board[2][1] == 2 && board[2][0] == 0) {
        board[2][0] = 2;
        return 1;
    }
    else if (board[0][2] == 2 && board[2][1] == 2 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else if (board[2][0] == 2 && board[0][1] == 2 && board[0][0] == 0) {
        board[0][0] = 2;
        return 1;
    }
    else if (board[2][2] == 2 && board[0][1] == 2 && board[0][2] == 0) {
        board[0][2] = 2;
        return 1;
    }
    else if (board[2][1] == 2 && board[1][2] == 2 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else if (board[1][2] == 2 && board[2][0] ==2 && board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    else {
        return 0;
    }
}
short int CChoose() {
    //Center Space
    if (board[1][1] == 0) {
        board[1][1] = 2;
        return 1;
    }
    //Corners
    else if (board[0][0] == 0) {
        board[0][0] = 2;
        return 1;
    }
    else if (board[0][2] == 0) {
        board[0][2] = 2;
        return 1;
    }
    else if (board[2][0] == 0) {
        board[2][0] = 2;
        return 1;
    }
    else if (board[2][2] == 0) {
        board[2][2] = 2;
        return 1;
    }
    //Sides
    else if (board[0][1] == 0) {
        board[0][1] = 2;
        return 1;
    }
    else if (board[1][0] == 0) {
        board[1][0] = 2;
        return 1;
    }
    else if (board[1][2] == 0) {
        board[1][2] = 2;
        return 1;
    }
    else {
        board[2][1] = 2;
        return 1;
    }
}
short int HWin() {
    if ( board[0][0] == 2 && board[0][1] == 2 && board[0][2] == 2) {
        return 1;
    }
    else if (board[0][0] == 2 && board[0][1] == 2 && board[0][2] == 2) {
        return 1;
    }
    else if (board[0][0] == 2 && board[0][1] == 2 && board[0][2] == 2) {
        return 1;
    }
    //Middle Row(4-5-6)
    else if (board[1][0] == 2 && board[1][1] == 2 && board[1][2] == 2) {
        return 1;
    }
    else if (board[1][0] == 2 && board[1][1] == 2 && board[1][2] == 2) {
        return 1;
    }
    else if (board[1][0] == 2 && board[1][1] == 2 && board[1][2] == 2) {
        return 1;
    }
    //Bottom Row(7-8-9)
    else if (board[2][0] == 2 && board[2][1] == 2 && board[2][2] == 2) {;
        return 1;
    }
    else if (board[2][0] == 2 && board[2][1] == 2 && board[2][2] == 2) {
        return 1;
    }
    else if (board[2][0] == 2 && board[2][1] == 2 && board[2][2] == 2) {
        return 1;
    }
    //Verticals
    //Left Collumn (1-4-7)
    else if (board[0][0] == 2 && board[1][0] == 2 && board[2][0] == 2) {
        return 1;
    }
    else if (board[0][0] == 2 && board[1][0] == 2 && board[2][0] == 2) {
        return 1;
    }
    else if (board[0][0] == 2 && board[1][0] == 2 && board[2][0] == 2) {
        return 1;
    }
   //Middle Collumn (2-5-8)
    else if (board[0][1] == 2 && board[1][1] == 2 && board[2][1] == 2) {
        return 1;
    }
    else if (board[0][1] == 2 && board[1][1] == 2 && board[2][1] == 2) {
        return 1;
    }
    else if (board[0][1] == 2 && board[1][1] == 2 && board[2][1] == 2) {
        return 1;
    }
    //Right Collumn (3-6-9)
    else if (board[0][2] == 2 && board[1][2] == 2 && board[2][2] == 2) {
        return 1;
    }
    else if (board[0][2] == 2 && board[1][2] == 2 && board[2][2] == 2) {
        return 1;
    }
    else if (board[0][2] == 2 && board[1][2] == 2 && board[2][2] == 2) {
        return 1;
    }
    //Diagonals
    //TR - BL (3-5-7)
    else if (board[0][2] == 2 && board[1][1] == 2 && board[2][0] == 2) {
        return 1;
    }
    else if (board[0][2] == 2 && board[1][1] == 2 && board[2][0] == 2) {
        return 1;
    }
    else if (board[0][2] == 2 && board[1][1] == 2 && board[2][0] == 2) {
        return 1;
    }
    //TL - BR (1-5-9)
    else if (board[0][0] == 2 && board[1][1] == 2 && board[2][2] == 2) {
        return 1;
    }
    else if (board[0][0] == 2 && board[1][1] == 2 && board[2][2] == 2) {
        return 1;
    }
    else if (board[0][0] == 2 && board[1][1] == 2 && board[2][2] == 2) {
        return 1;
    }
    //Can't Win
    else {
        return 0;
    }
}

short int CMove() {
    //Can Computer Win?
    if ( CWin() == 1 ) {
        return 0;
    }
    //Will Human Win?
    else if( BlockH() == 1 ) { 
        return 0;
    }
    //Is the Person Smart?
    else if (BlockSH() == 1) {     
        return 0;
    }
    //Choose A Space
    else {
        CChoose();    
        return 0;
    }
}

void _main(void) {
	//Clear the Screen
	ClrScr();
	//Initialize the board
	short int a;
	short int b;
	cont = 0;
	for (a = 0; a < 3; a++) {
		for (b = 0; b < 3; b++) {
			board[a][b] = 0;
		}
	}
	//Clear Screen and Print Welcome Message
	ClrScr();
	DrawStr(0, 0, "Welcome to TicTacToe", A_NORMAL);
	//Each square is 29 pixels
	//Horizontal Lines
	DrawLine(35, 39, 124, 39, A_NORMAL);
	DrawLine(35, 69, 124, 69, A_NORMAL);
	//Vertical Lines
	DrawLine(64, 10, 64, 99, A_NORMAL);
	DrawLine(94, 10, 94, 99, A_NORMAL);
	//Wait for user to press a key before starting
	getkey();
	//Main Game Loop
	while (cont == 0) {
		//Ask appropriate player to enter row and column
		//Could use sprintf, but is easier to just use if
		DrawStr(0, 0, "It is the human's turn", A_REPLACE);
		//Get Row and Column
		int number;
		do {
			number = getkey() - 48;
			row = (number % 3 == 0) ? 2 : ((number % 3) - 1);
			column = (((number + 2) / 3) - 1);
			column = 2 - column;
		} while ((number < 1) || (number > 9) || (board[row][column] != 0));
		board[row][column] = 1;
		//Check Win/Tie
		if (Win(1) == 1) {
			//Again, could just use sprintf
			//Have to XOR the turn message first
			DrawStr(0, 0, "It is the human's turn", A_XOR);
			DrawStr(0, 0, "The Human Wins!", A_REPLACE);
			cont = 1;
		}
		if (Tie() == 1) {
			DrawStr(0, 0, "It is the human's turn", A_XOR);
			DrawStr(0, 0, "It's a Tie!", A_REPLACE);
			cont = 1;
		}
		if (cont == 0)
			CMove();
		//Refresh the board
		for (i = 0; i < 3; i++) {
			for (j = 0; j < 3; j++) {
				if (board[i][j] == 1)
					Sprite16(43+(i*30), 18+(j*30), 16, x, LCD_MEM, SPRT_OR);
				if (board[i][j] == 2)
					Sprite16(43+(i*30), 18+(j*30), 16, o, LCD_MEM, SPRT_OR);
			}
		}
		//Check Win
		if (Win(2) == 1) {
			//Again, could just use sprintf
			//Have to XOR the turn message first
			DrawStr(0, 0, "It is the human's turn", A_XOR);
			DrawStr(0, 0, "The Computer Wins!", A_REPLACE);
			cont = 1;
		}
	}
	getkey();
}